# Icon图标

### 介绍
按钮用于触发一个操作

###效果图
![效果图](https://img.tanjiu.cn/home/eRzWjCbMsFbr6knYRcF2npEcjHAXEYFQ.png "Button效果图")

### 引入
在app.json或页面配置json中引入
```
"usingComponents": {
    "xt-button": "@xtdev/xt-miniprogram-ui/xt-button",
}
```

## 代码演示

### 基础用法

```
    <xt-button type="main">默认状态</xt-button>
```

##API

####xt-button props

| 参数         | 说明        |  类型      |  默认值        |
| ----------- | ----------- | ---------- | ------------  |
| type      | 按钮类型，可选值为 `main` `secondary` | string |  `secondary`
| size      | 按钮尺寸，可选值为 `normal` `large` `small` | string | `normal`
| icon      | 左侧图标名称                          | string |
| disabled  | 是否禁用按钮                      | boolean | `false`
| open-type      | 微信开放能力，具体支持可参考[微信官方文档](https://developers.weixin.qq.com/miniprogram/dev/component/button.html) | string |
| app-parameter      | 打开 APP 时，向 APP 传递的参数 | string |    
| lang      | 指定返回用户信息的语言，zh_CN 简体中文，zh_TW 繁体中文，en 英文 | string |    `en`
| session-from      | 会话来源 | string |    
| business-id      | 客服消息子商户 id | number |    
| send-message-title      | 会话内消息卡片标题 | string |  当前标题  
| send-message-path      | 会话内消息卡片点击跳转小程序路径 | string |    当前分享路径
| send-message-img      | sendMessageImg | string |    截图
| show-message-card     | 显示会话内消息卡片 | string |   `false`
| dataset      | 按钮 dataset，open-type 为 share 时，可在 onShareAppMessage 事件的 `event.target.dataset.detail` 中看到传入的值 | any |    



####Events

| 事件名            | 说明          |  回调参数               |
| ---------------- | ------------- | ---------------------- |
| bind:click      | 点击按钮，且按钮状态不为加载或禁用时触发 | 
| bind:getuserinfo      | 用户点击该按钮时，会返回获取到的用户信息，
从返回参数的 detail 中获取到的值同 wx.getUserInfo |
| bind:contact      | 客服消息回调 | 
| bind:getphonenumber      | 获取用户手机号回调 | 
| bind:getrealtimephonenumber       | 获取手机号实时验证回调，open-type=getRealtimePhoneNumber 时有效 |
| bind:error      | 当使用开放能力时，发生错误的回调 | 
| bind:opensetting      | 在打开授权设置页后回调 | 
| bind:chooseavatar      | 当 open-type 的值为 chooseAvatar 时，选择头像之后的回调 | 
