Component({
  behaviors: [],
  observers: {},
  properties: {
    zIndx: {
      type: Number,
      value: 999,
      observer: function () {},
    },
    // 弹窗标题
    title: {
      type: String,
      value: "",
      observer: function () {},
    },
    // 弹窗类型
    type: {
      type: String,
      value: "operate",
      observer: function () {},
    },
    show: {
      type: Boolean,
      value: false,
      observer: async function (val) {
        if (val) {
          const res = await this.findIntersection();
          this.setData({
            sourceData: res,
          });
        }
      },
    },
    showCloseIcon: {
      type: Boolean,
      value: true,
      observer: function (val) {},
    },

    // 文本内容
    textContent: {
      type: String,
      value: "",
      observer: function () {},
    },
    // 列表每一项标题内容
    itemTextKey: {
      type: String,
      value: "",
      observer: function () {},
    },
    // 操作
    operates: {
      type: Array,
      value: [],
      observer: function () {},
    },
    // 源数据
    sourceData: {
      type: Array,
      value: [],
      observer: function (val) {},
    },
    // 选中数据
    selectData: {
      type: Array,
      value: [],
      observer: async function () {},
    },
    // 数据对比字段，用于找出选中的数据
    contrastId: {
      type: String,
      value: "",
      observer: function () {},
    },
  },
  data: {
    sourceData: [],
    multipleChooseData: [],
  },
  methods: {
    closePopover() {
      this.triggerEvent("onClose");
      this.resetSourceData();
    },

    async findIntersection() {
      const { sourceData, selectData, contrastId, type } = this.data;

      for (const selectItem of selectData) {
        for (const sourceItem of sourceData) {
          if (type === "multiple") {
            if (selectItem[contrastId] == sourceItem[contrastId]) {
              sourceItem.selected = true;
            }
          } else {
            if (selectItem[contrastId] == sourceItem[contrastId]) {
              sourceItem.selected = true;
            } else {
              sourceItem.selected = false;
            }
          }
        }
      }
      return this.deepClone(sourceData);
    },
    // 重置数据
    async resetSourceData() {
      const { sourceData } = this.data;
      for (const sourceItem of sourceData) {
        delete sourceItem.selected;
      }

      this.setData({
        sourceData: this.deepClone(sourceData),
      });
    },

    async formatSourceData(chooseItem) {
      const { sourceData, contrastId } = this.data;
      for (const sourceItem of sourceData) {
        if (
          chooseItem[contrastId] == sourceItem[contrastId] &&
          sourceItem.selected
        ) {
          sourceItem.selected = false;
        } else if (
          chooseItem[contrastId] == sourceItem[contrastId] &&
          !sourceItem.selected
        ) {
          sourceItem.selected = true;
        }
      }
      return sourceData;
    },

    confirm() {
      const { sourceData } = this.data;
      const chooseData = sourceData.filter((item) => item.selected);

      const deleteSelected = chooseData.map((item) => {
        delete item.selected;
        return item;
      });
      this.triggerEvent("onConfirm", { chooseData: deleteSelected });
    },

    async chooseItemClick(event) {
      const chooseItem = event.currentTarget.dataset.item;
      const { type } = this.data;

      if (type == "single") {
        delete chooseItem.selected;
        this.triggerEvent("onChooseItemClick", { chooseItem });
      } else if (type == "multiple") {
        const res = await this.formatSourceData(chooseItem);

        this.setData({
          sourceData: this.deepClone(res),
        });
      } else {
        this.triggerEvent("onChooseItemClick", { chooseItem });
      }
    },

    deepClone(target, map = new Map()) {
      if (typeof target === "object") {
        const isArray = Array.isArray(target);
        let cloneTarget = isArray ? [] : {};

        if (map.get(target)) {
          return map.get(target);
        }
        map.set(target, cloneTarget);

        const keys = isArray ? undefined : Object.keys(target);
        this.forEach(keys || target, (value, key) => {
          if (keys) {
            key = value;
          }
          cloneTarget[key] = this.deepClone(target[key], map);
        });

        return cloneTarget;
      } else {
        return target;
      }
    },
    forEach(array, iteratee) {
      let index = -1;
      const length = array.length;
      while (++index < length) {
        iteratee(array[index], index);
      }
      return array;
    },
  },
  pageLifetimes: {
    // 组件所在页面的生命周期函数
    show: function () {},
    hide: function () {},
    resize: function () {},
  },
  created: function () {},
  attached: function () {},
  ready: function () {},
  moved: function () {},
  detached: function () {},
});
