# Icon图标

### 介绍
选项卡组件，用于在不同的内容区域之间进行切换

###效果图
![效果图](https://img.tanjiu.cn/home/NbcpQMpKZNCerYMy5ETZ3fwFBaCQjGS3.png "选项卡效果图")

### 引入
在app.json或页面配置json中引入
```
"usingComponents": {
    "xt-tabs": "@xtdev/xt-miniprogram-ui/xt-tabs",
}
```

## 代码演示

### 基础用法

```
<xt-tabs list="{{list}}"></xt-tabs>
```
```
  data: {
    list: [
      {
        title: '标签一'
      },
      {
        title: '标签二'
      },
    ],
  }
```

### 带副标题
```
<xt-tabs list="{{subTitlelist}}"></xt-tabs>
```
```
  data: {
    subTitlelist: [
      {
        title: '标签一',
        subTitle: '副标题'
      },
      {
        title: '标签二',
        subTitle: '副标题'
      },
    ],
  }
```

### 卡片模式
支持两种样式风格：line和card，默认为line样式，可以通过type属性修改样式风格
```
<xt-tabs type="card" list="{{list}}"></xt-tabs>
```
```
  data: {
    list: [
      {
        title: '标签一'
      },
      {
        title: '标签二'
      },
    ],
  }
```

##API

####xt-tabs props

| 参数      | 说明 |  类型 |
| ----------- | ----------- | ---------- |
| type      | 样式风格，可选值`card`、`line`,默认值为`line` | `String` |
| active   | 当前选中标签的标识符，默认值0  | `Number` |
| list   | 数据源数组  | `ItemProps` |
| cardBgColor   | tab背景色 | `String` |
| borderColor   | tab边框颜色 | `String` |

#### ItemProps

| 参数      | 说明 | 类型 |
| ----------- | ----------- | ----------- |
| title      | 卡片标题 | `String` |
| subTitle   | 卡片副标题  | `String` |
| titleColor   | 标题颜色  | `String` |

#### Tabs Event

| 事件名      | 说明 | 参数 |
| ----------- | ----------- | ----------- |
| bind:change      | tab点击事件 | 当前激活项数据以及索引 |
