// src/xt-toast/index.js
Component({
    /**
     * 组件的属性列表
     */
    properties: {
      show:{
        type:Boolean,
        value:false
      },
      type:{
        type:String,
        value:'nomal'
      },
      duration:{
        type:Number,
        value:5000
      },
      message:{
        type:String,
        value:''
      },
      navDuration:{
        type:Number,
        value:null
      },
      navUrl:{
        type:String,
        value:null
      }
    },

    /**
     * 组件的初始数据
     */
    data: {
      // 带跳转的toast是否允许自动消失
      dispear: false
    },
    observers:{
      show(val){
        if(val){
          this.showToast();
        }
      }
    },
    lifetimes:{
      attached(){
        // if(this.properties.type == 'nomal') this.showToast();
        if(this.properties.type == 'navToast') this.showNavToast();
      }
    },
    /**
     * 组件的方法列表
     */
    methods: {
      // 常规toast
      showToast(){
        console.log('查看变量',this.properties.show);
        wx.showToast({
          title: this.properties.message,
          duration: this.properties.duration,
          icon:'none'
        })
      },
      // 带跳转的提示
      showNavToast(){
        if(this.properties.navDuration){
          setTimeout(()=>{
            this.setData({
              dispear: true
            })
          },this.properties.navDuration)
        }
      },
      // 点击提示框跳转至目标页面
      navTo(){
        if(this.properties.navUrl){
          wx.navigateTo({
            url: this.properties.navUrl,
          })
        }
      }
    }
})
