// import md5 from "md5";

function newhttpRequest(url, method, params, header, callBack) {
	wx.request({
		url,
		method: method,
		header: {
			"content-type": "application/json",
			// Authorization: md5(pass),
			token: "openApi",
			...header,
		},
		data: params,
		success(res) {
			if (res.data) {
				var result = {
					data: res.data.data || res.data.retdata || res,
					message: res.data.message || res.data.errMsg,
					code:
						res.data.code ||
						res.data.errCode ||
						(res.data.code == 0 || res.data.errCode == 0 ? 0 : null),
				};
				callBack(result);
			}
		},
		fail(err) {
			var result = {
				success: false,
				data: {},
				message: err.errMsg || err.msg,
			};
			wx.showToast({
				title: result.message || "请检查网络是否通畅，稍后重试！",
				icon: "none",
			});
			console.log("err = ", err);
			callBack(result);
		},
	});
}

function random_string(len) {
	len = len || 32;
	let chars = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678";
	let maxPos = chars.length;
	let pwd = "";
	for (let i = 0; i < len; i++) {
		pwd += chars.charAt(Math.floor(Math.random() * maxPos));
	}
	return pwd;
}

// 解密
function get_suffix(filename) {
	console.log(filename, "filename");
	let pos = filename.lastIndexOf(".");
	let suffix = "";
	if (pos != -1) {
		suffix = filename.substring(pos);
	}
	return suffix;
}

module.exports = {
	newHttp: newhttpRequest,
	random_string,
	get_suffix,
};
